-- there is a namspace cog. through which all
-- manipulation is made with the people counter and the outside world
-- examples of usage is listed below
--
-- you can declare global variables like i but the state will be lost when the counter restarts
-- there for it is best to also save them in a parameter

i = 0

-- the parameter system permits permament setting variables
cog.ParamNew("myi", tostring(0))
i = tonumber(cog.ParamGet("myi"))

-- example of a webresult
-- the Webpage call takes for parameters
-- 1 name of new webpage,
-- 2 callback that takes a table argument,
-- 3 a list of what uri parameters we want to use when generating the page,
-- 4 the returning mime type of the page

function webpage(table)
    return string.format([[
        <html>
        <head>
        <title>Current Passages</title>
        </head>
        <body>
            right now there was %d persons, this page was called with info: %q
        </body>
        </html>
        ]], i, table["info"] or "")
end
cog.Webpage("my-special", webpage, {"info"}, "text/html")

-- there are diffrent callbacks that one can register for
-- the documentation is incomplete but the main feature is demonstrated here
function cnt (cnt_type, cnt, ts)
    -- cnt_type = 3 for in and 4 for out
    -- cnt is the number of passages just happend
    -- ts is the unix timestamp for the passage in epoch time
    i = cnt + i
    cog.ParamSet("myi", tostring(i))
    if i>5 then
        cog.Trigger("more_than_five")
    end
end

-- cnt_event is triggered each time a person walks under the camera.
cog.Callback("cnt_event", cnt)
-- at midnight the count data for this day is reset, you can listen for this event.
cog.Callback("day_reset", function() print("day has been reseted ", os.time()) end)


-- here is an example of timer usage
function every_time ()
    print("there are 3 people-dancing")
    if i>10 then
        print("phew dont wanna dance anymore")
        cog.ClearTimer("dance")
    end
end
cog.Timer(every_time, 10000, "dance")


--here is an example of listing and getting parameters from the counter
tab = cog.ParamList()
for i=0, #tab do
    print(i, tab[i], cog.ParamGet(tab[i]))
end

-- for the use of triggers the TriggerInit must
-- be called in the initation phase of the script
cog.TriggerInit("mytrigger")

